#!/usr/bin/perl
#
# hex2bin.pl - Convert an Intel hex file (for the LED Toy) to a downloadable
#              binary
#
# Written 2005 by Werner Almesberger
# Copyright 2005 by Werner Almesberger
#


while (<>) {
    chop;
    next unless /^:..(....)00(.*)..$/;
    $addr = hex($1);
    next if $addr < 0x200 || $addr > 0x1fff;
    while ($addr > $p) { $data[$p++] = pack("C",0xff); }
    for ($l = $2; $l =~ /^../; $l = $n) {
	$n = $';	# odd, $' is lost in the loop
	$data[$p++] = pack("C",hex($&));
    }
}
for ($i = 0x200; $i != $p; $i++) {
    print $data[$i];
}
